<template>
  <div 
    style="
      position: relative; 
      width: 100vw; 
      height: 100%; 
      overflow: hidden; 
      box-sizing: border-box;
    "
  >
    <div>
      
    </div>

    <div
      v-show="isSwipeHandlerHidden === false"
      style="
        position: absolute;
        height: 100%;
        width: 100%;
        z-index: 1;
      "
      @touchmove.stop="handleTouchMove($event)"
      @touchstart.stop="handleTouchStart($event)" 
    >

    <transition
      enter-active-class="animate__animated animate__slideInRight"
      :leave-active-class="goodsListLeaveClass"
    >
        
        <TheGoodsList 
          v-if="steps === 2" 
          :goodsList="goodsList" 
          @back="steps = 1"
          @addGood="addGood" 
          @removeGood="removeGood" 
        />
        <!-- debug -->
        <!-- <div>
          goodsList: <br>
          <div style="margin: 20px;" v-for="good in goodsList" :key="good.id">
            {{ good }}
          </div>
        </div> -->
    </transition>

    
    <TheCredentialsMenu 
      @auth="steps = 3" 
      @address="steps = 4"
      @card="steps = 6"
      @goodsList="steps = 2"
      @shopsList="steps = 8"
      @tipClosed="tipsStatus.credentialsMenu = false"
      
      :mainShop="mainShop"
      :basketSize="basketSize" 
      :basketSum="basketSum" 
      :isAuth="isAuth"
      :mainCard="mainCard"
      :mainAddress="mainAddress"
      :isTipOpen="tipsStatus.credentialsMenu"
      style="z-index: -1;"
    />
    

    <transition
      enter-active-class="animate__animated animate__slideInRight"
      :leave-active-class="goodsListLeaveClass"
    >
      <TheAuthMenu 
        v-if="steps === 3"
        :isTipOpen="tipsStatus.authMenu"
        @authSuccess="isAuth = true; steps = 1" 
        @back="steps = 1"
        @tipClosed="tipsStatus.authMenu = false"
      />
    </transition>

    <transition
      enter-active-class="animate__animated animate__slideInRight"
      :leave-active-class="goodsListLeaveClass"
    >
      <TheChooseCard 
        v-if="steps === 6" 
        :cardsList="formatCardsList" 
        :isTipOpen="tipsStatus.chooseCard"
        @click="steps = 7" 
        @back="steps = 1"
        @chooseCard="chooseCard($event)" 
        @tipClosed="tipsStatus.chooseCard = false"
      />
    </transition>

    <transition
      enter-active-class="animate__animated animate__slideInRight"
      :leave-active-class="goodsListLeaveClass"
    >
      <TheAddCard 
        v-show="steps === 7" 
        :isTipOpen="tipsStatus.addCard"
        @click="addCard($event)" 
        @back="steps = 1"
        @swipeRight="swipeRight()"
        @tipClosed="tipsStatus.addCard = false"
      />
    </transition>

    <transition
      enter-active-class="animate__animated animate__slideInRight"
      :leave-active-class="goodsListLeaveClass"
    >
      <TheChooseAddress 
        v-if="steps === 4" 
        :isTipOpen="tipsStatus.chooseAddress"
        @click="steps = 5" 
        @back="steps = 1"
        @chooseAddress="chooseAddress($event)" 
        @tipClosed="tipsStatus.chooseAddress = false"
      />
    </transition>

    <transition
      enter-active-class="animate__animated animate__slideInRight"
      :leave-active-class="goodsListLeaveClass"
    >
      <TheAddAddress 
        v-show="steps === 5" 
        :isTipOpen="tipsStatus.addAddress"
        @tipClosed="tipsStatus.addAddress = false"
        @back="steps = 1"
        @click="addAddress($event)" 
      />
    </transition>

    <transition
      enter-active-class="animate__animated animate__slideInRight"
      :leave-active-class="goodsListLeaveClass"
    >
      <TheShopsList 
        v-show="steps === 8" 
        :shopsList="shopsList"
        @back="steps = 1"
        @chooseShop="chooseShop($event)" 
      />
    </transition>
    </div>

  </div>
</template>

<script>
import TheGoodsList from '@/components/TheGoodsList.vue';
import TheShopsList from '@/components/TheShopsList.vue';
import TheCredentialsMenu from '@/components/TheCredentialsMenu.vue';
import TheAuthMenu from '@/components/TheAuthMenu.vue';
import TheChooseCard from '@/components/TheChooseCard.vue';
import TheAddCard from '@/components/TheAddCard.vue';
import TheChooseAddress from '@/components/TheChooseAddress.vue';
import TheAddAddress from '@/components/TheAddAddress.vue';

export default {
  data() {
    return {

      goodsList: this.$store.state.inventories,

      shopsList: [
        {id: 100001, name: 'Магазин', coords: [55.55, 44.44]},
        {id: 100002, name: 'Овощная лавка', coords: [55.55, 44.44]},
      ],

      xDown: null,
      yDown: null,

      cardsList: [
        {id: "8495 4985 3849 3049"},
      ],

      tipsStatus: {
        chooseAddress: true,
        credentialsMenu: true,
        addAddress: true,
        chooseCard: true,
        addCard: true,
        authMenu: true,
      },

      isAuth: false,
      mainCard: null,
      mainAddress: null,
      mainShop: null,
      steps: 1,
      goodsListLeaveClass: 'animate__animated animate__slideOutRight',
      isSwipeHandlerHidden: false,
    }
  },
  components: { 
    TheGoodsList,
    TheCredentialsMenu,
    TheAuthMenu,
    TheChooseCard,
    TheAddCard,
    TheChooseAddress,
    TheAddAddress,
    TheShopsList
  },

  created() {
    if (localStorage.getItem('token')) {
      this.$store.commit('SET_IS_AUTH', { isAuth: true });
    }

    this.$store.dispatch('getCards');
    this.$store.dispatch('GET_ADDRESSES');
    this.$store.dispatch('GET_SHOPS');
    this.$store.dispatch('getShopInventories');
  },

  methods: {

    handleTouchMove(evt) {
      if ( !this.xDown || !this.yDown ) {
          return;
      }

      var xUp = evt.touches[0].clientX;                                    
      var yUp = evt.touches[0].clientY;

      var xDiff = this.xDown - xUp;
      var yDiff = this.yDown - yUp;
                                                                          
      if ( Math.abs( xDiff ) > Math.abs( yDiff ) ) {
        if ( xDiff > 0 ) {
          /* влево */
          // evt.preventDefault();
          // evt.stopPropagation();
 
        } else {
          /* вправо */
          evt.preventDefault();
          evt.stopPropagation();

          this.goodsListLeaveClass = 'animate__animated animate__slideOutRight';

          // if (this.steps === 1) {
          //   this.$nextTick(() => { 
          //     this.steps = 0;
          //     setTimeout(() => {
          //       // this.isSwipeHandlerHidden = true;
          //     }, 500);
          //   }, 0);
          // }

          if (this.steps === 2) {
            this.$nextTick(() => { 
              this.steps = 1;
            }, 0);
          }

          if (this.steps === 3) {
            this.$nextTick(() => { 
              this.steps = 1;
            }, 0);
          }

          if (this.steps === 4) {
            this.$nextTick(() => { 
              this.steps = 1;
            }, 0);
          }

          if (this.steps === 5) {
            this.$nextTick(() => { 
              this.steps = 4;
            }, 0);
          }

          if (this.steps === 6) {
            this.$nextTick(() => { 
              this.steps = 1;
            }, 0);
          }

          if (this.steps === 7) {
            this.$nextTick(() => { 
              this.steps = 6;
            }, 0);
          }

          if (this.steps === 8) {
            this.$nextTick(() => { 
              this.steps = 1;
            }, 0);
          }
          
        }                       
      }

      /* reset values */
      this.xDown = null;
      this.yDown = null;                                             
    },

    getTouches(evt) {
      return evt.touches ||             // browser API
            evt.originalEvent.touches; // jQuery
    },

    handleTouchStart(evt) {
      const firstTouch = this.getTouches(evt)[0];
      this.xDown = firstTouch.clientX;
      this.yDown = firstTouch.clientY;
    },

    addGood(index) {
      this.goodsList[index].chosenAmount += 1;
    },

    removeGood(index) {
      this.goodsList[index].chosenAmount -= 1;
    },

    chooseAddress(index) {
      this.mainAddress = this.addressList[index];
      this.steps = 1;
    },

    // выбор по индексу потом надо будет переделать, когда добавлю фильтры. Массивы в меню и оригинал будут отличаться
    chooseShop(index) {
      this.mainShop = this.shopsList[index];
      this.steps = 1;
    },

    chooseCard(index) {
      this.mainCard = this.cardsList[index];
      this.steps = 1;
    },

    addCard(e) {
      this.cardsList.push({id: e});
      this.mainCard = this.cardsList[this.cardsList.length-1];
      this.steps = 1;
    },

    addAddress() {
      // this.addressList.push({address: e, coords: [55.55, 44.44]});
      this.mainAddress = this.addressList[this.addressList.length-1];
      this.steps = 1;
    },

    // swipeRight() {
    //   this.goodsListLeaveClass = 'animate__animated animate__slideOutRight';

    //   this.$nextTick(() => { 
    //     this.steps = 6;
    //   }, 0);
    // }


  },
  computed: {

    key() {
      return this.$store.state.key;
    },

    token() {
      return this.$store.state.accessToken;
    },

    isAuthed() {
      return this.$store.state.isAuth;
    },

    basketSize() {
      let size = 0;

      for (let i = 0; i < this.goodsList.length; i++) {
        if (this.goodsList[i].chosenAmount > 0) {
          size += this.goodsList[i].chosenAmount;
        }
      }
      return size;
    },

    basketSum() {
      let sum = 0;

      for (let i = 0; i < this.goodsList.length; i++) {
        if (this.goodsList[i].chosenAmount > 0) {
          sum += this.goodsList[i].chosenAmount * this.goodsList[i].price;
        }
      }
      return sum.toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ");  // пробелы после каждые 3 знака
    },

    formatCardsList() {
      if (!this.cardsList) return;
      let copy = [];
      for (let i = 0; i < this.cardsList.length; i++) {
        let obj = this.cardsList[i];
        let shortID = obj.id.slice(-4);
        copy.push({...obj, id: shortID});
      }
      return copy;
      // return this.cardsList.map((card) => {
      //   card.id = '•• ' + card.id.slice(-4);
      //   return card;
      // })
    }
  }
}
</script>